from asdl import pybase

option_t = int  # type alias for integer

class option_i(object):
  errexit = 1
  nounset = 2
  hashall = 3
  pipefail = 4
  noexec = 5
  xtrace = 6
  verbose = 7
  noglob = 8
  noclobber = 9
  posix = 10
  vi = 11
  emacs = 12
  interactive = 13
  failglob = 14
  extglob = 15
  eval_unsafe_arith = 16
  parse_dynamic_arith = 17
  compat_array = 18
  verbose_errexit = 19
  nullglob = 20
  inherit_errexit = 21
  strict_argv = 22
  strict_arith = 23
  strict_array = 24
  strict_control_flow = 25
  strict_echo = 26
  strict_errexit = 27
  strict_eval_builtin = 28
  strict_nameref = 29
  strict_word_eval = 30
  strict_backslash = 31
  strict_glob = 32
  simple_word_eval = 33
  dashglob = 34
  more_errexit = 35
  simple_test_builtin = 36
  parse_at = 37
  parse_brace = 38
  parse_index_expr = 39
  parse_paren = 40
  parse_rawc = 41
  parse_ignored = 42
  parse_set = 43
  parse_equals = 44
  parse_tea = 45
  expand_aliases = 46
  lastpipe = 47
  progcomp = 48
  histappend = 49
  hostcomplete = 50
  cmdhist = 51
  assoc_expand_once = 52
  autocd = 53
  cdable_vars = 54
  cdspell = 55
  checkhash = 56
  checkjobs = 57
  checkwinsize = 58
  complete_fullquote = 59
  direxpand = 60
  dirspell = 61
  dotglob = 62
  execfail = 63
  extdebug = 64
  extquote = 65
  force_fignore = 66
  globasciiranges = 67
  globstar = 68
  gnu_errfmt = 69
  histreedit = 70
  histverify = 71
  huponexit = 72
  interactive_comments = 73
  lithist = 74
  localvar_inherit = 75
  localvar_unset = 76
  login_shell = 77
  mailwarn = 78
  no_empty_cmd_completion = 79
  nocaseglob = 80
  nocasematch = 81
  progcomp_alias = 82
  promptvars = 83
  restricted_shell = 84
  shift_verbose = 85
  sourcepath = 86
  xpg_echo = 87
  ARRAY_SIZE = 88

_option_str = {
  1: 'option.errexit',
  2: 'option.nounset',
  3: 'option.hashall',
  4: 'option.pipefail',
  5: 'option.noexec',
  6: 'option.xtrace',
  7: 'option.verbose',
  8: 'option.noglob',
  9: 'option.noclobber',
  10: 'option.posix',
  11: 'option.vi',
  12: 'option.emacs',
  13: 'option.interactive',
  14: 'option.failglob',
  15: 'option.extglob',
  16: 'option.eval_unsafe_arith',
  17: 'option.parse_dynamic_arith',
  18: 'option.compat_array',
  19: 'option.verbose_errexit',
  20: 'option.nullglob',
  21: 'option.inherit_errexit',
  22: 'option.strict_argv',
  23: 'option.strict_arith',
  24: 'option.strict_array',
  25: 'option.strict_control_flow',
  26: 'option.strict_echo',
  27: 'option.strict_errexit',
  28: 'option.strict_eval_builtin',
  29: 'option.strict_nameref',
  30: 'option.strict_word_eval',
  31: 'option.strict_backslash',
  32: 'option.strict_glob',
  33: 'option.simple_word_eval',
  34: 'option.dashglob',
  35: 'option.more_errexit',
  36: 'option.simple_test_builtin',
  37: 'option.parse_at',
  38: 'option.parse_brace',
  39: 'option.parse_index_expr',
  40: 'option.parse_paren',
  41: 'option.parse_rawc',
  42: 'option.parse_ignored',
  43: 'option.parse_set',
  44: 'option.parse_equals',
  45: 'option.parse_tea',
  46: 'option.expand_aliases',
  47: 'option.lastpipe',
  48: 'option.progcomp',
  49: 'option.histappend',
  50: 'option.hostcomplete',
  51: 'option.cmdhist',
  52: 'option.assoc_expand_once',
  53: 'option.autocd',
  54: 'option.cdable_vars',
  55: 'option.cdspell',
  56: 'option.checkhash',
  57: 'option.checkjobs',
  58: 'option.checkwinsize',
  59: 'option.complete_fullquote',
  60: 'option.direxpand',
  61: 'option.dirspell',
  62: 'option.dotglob',
  63: 'option.execfail',
  64: 'option.extdebug',
  65: 'option.extquote',
  66: 'option.force_fignore',
  67: 'option.globasciiranges',
  68: 'option.globstar',
  69: 'option.gnu_errfmt',
  70: 'option.histreedit',
  71: 'option.histverify',
  72: 'option.huponexit',
  73: 'option.interactive_comments',
  74: 'option.lithist',
  75: 'option.localvar_inherit',
  76: 'option.localvar_unset',
  77: 'option.login_shell',
  78: 'option.mailwarn',
  79: 'option.no_empty_cmd_completion',
  80: 'option.nocaseglob',
  81: 'option.nocasematch',
  82: 'option.progcomp_alias',
  83: 'option.promptvars',
  84: 'option.restricted_shell',
  85: 'option.shift_verbose',
  86: 'option.sourcepath',
  87: 'option.xpg_echo',
}

def option_str(val):
  # type: (option_t) -> str
  return _option_str[val]

builtin_t = int  # type alias for integer

class builtin_i(object):
  colon = 1
  dot = 2
  exec_ = 3
  eval = 4
  set = 5
  shift = 6
  times = 7
  trap = 8
  unset = 9
  builtin = 10
  readonly = 11
  local = 12
  declare = 13
  typeset = 14
  export_ = 15
  test = 16
  bracket = 17
  true_ = 18
  false_ = 19
  read = 20
  echo = 21
  printf = 22
  mapfile = 23
  readarray = 24
  cd = 25
  pushd = 26
  popd = 27
  dirs = 28
  pwd = 29
  source = 30
  umask = 31
  wait = 32
  jobs = 33
  fg = 34
  bg = 35
  shopt = 36
  complete = 37
  compgen = 38
  compopt = 39
  compadjust = 40
  getopts = 41
  command = 42
  type = 43
  hash = 44
  help = 45
  history = 46
  alias = 47
  unalias = 48
  bind = 49
  push = 50
  append = 51
  write = 52
  getline = 53
  json = 54
  repr = 55
  use = 56
  opts = 57
  cat = 58
  ARRAY_SIZE = 59

_builtin_str = {
  1: 'builtin.colon',
  2: 'builtin.dot',
  3: 'builtin.exec_',
  4: 'builtin.eval',
  5: 'builtin.set',
  6: 'builtin.shift',
  7: 'builtin.times',
  8: 'builtin.trap',
  9: 'builtin.unset',
  10: 'builtin.builtin',
  11: 'builtin.readonly',
  12: 'builtin.local',
  13: 'builtin.declare',
  14: 'builtin.typeset',
  15: 'builtin.export_',
  16: 'builtin.test',
  17: 'builtin.bracket',
  18: 'builtin.true_',
  19: 'builtin.false_',
  20: 'builtin.read',
  21: 'builtin.echo',
  22: 'builtin.printf',
  23: 'builtin.mapfile',
  24: 'builtin.readarray',
  25: 'builtin.cd',
  26: 'builtin.pushd',
  27: 'builtin.popd',
  28: 'builtin.dirs',
  29: 'builtin.pwd',
  30: 'builtin.source',
  31: 'builtin.umask',
  32: 'builtin.wait',
  33: 'builtin.jobs',
  34: 'builtin.fg',
  35: 'builtin.bg',
  36: 'builtin.shopt',
  37: 'builtin.complete',
  38: 'builtin.compgen',
  39: 'builtin.compopt',
  40: 'builtin.compadjust',
  41: 'builtin.getopts',
  42: 'builtin.command',
  43: 'builtin.type',
  44: 'builtin.hash',
  45: 'builtin.help',
  46: 'builtin.history',
  47: 'builtin.alias',
  48: 'builtin.unalias',
  49: 'builtin.bind',
  50: 'builtin.push',
  51: 'builtin.append',
  52: 'builtin.write',
  53: 'builtin.getline',
  54: 'builtin.json',
  55: 'builtin.repr',
  56: 'builtin.use',
  57: 'builtin.opts',
  58: 'builtin.cat',
}

def builtin_str(val):
  # type: (builtin_t) -> str
  return _builtin_str[val]

